diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/plugin-install.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/plugin-install.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/plugin-install.php	2012-10-29 12:35:31.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/plugin-install.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 74,80 ****
  	if ( is_wp_error($tags) )
  		return $tags;
  
! 	set_site_transient('poptags_' . $key, $tags, 10800); // 3 * 60 * 60 = 10800
  
  	return $tags;
  }
--- 74,80 ----
  	if ( is_wp_error($tags) )
  		return $tags;
  
! 	set_site_transient( 'poptags_' . $key, $tags, 3 * HOUR_IN_SECONDS );
  
  	return $tags;
  }
***************
*** 128,134 ****
  			<option value="tag"<?php selected('tag', $type) ?>><?php _ex('Tag', 'Plugin Installer'); ?></option>
  		</select>
  		<?php endif; ?>
! 		<input type="search" name="s" value="<?php echo esc_attr($term) ?>" />
  		<label class="screen-reader-text" for="plugin-search-input"><?php _e('Search Plugins'); ?></label>
  		<?php submit_button( __( 'Search Plugins' ), 'button', 'plugin-search-input', false ); ?>
  	</form><?php
--- 128,134 ----
  			<option value="tag"<?php selected('tag', $type) ?>><?php _ex('Tag', 'Plugin Installer'); ?></option>
  		</select>
  		<?php endif; ?>
! 		<input type="search" name="s" value="<?php echo esc_attr($term) ?>" autofocus="autofocus" />
  		<label class="screen-reader-text" for="plugin-search-input"><?php _e('Search Plugins'); ?></label>
  		<?php submit_button( __( 'Search Plugins' ), 'button', 'plugin-search-input', false ); ?>
  	</form><?php
***************
*** 142,160 ****
   */
  function install_plugins_upload( $page = 1 ) {
  ?>
! 	<h4><?php _e('Install a plugin in .zip format') ?></h4>
! 	<p class="install-help"><?php _e('If you have a plugin in a .zip format, you may install it by uploading it here.') ?></p>
! 	<form method="post" enctype="multipart/form-data" action="<?php echo self_admin_url('update.php?action=upload-plugin') ?>">
! 		<?php wp_nonce_field( 'plugin-upload') ?>
  		<label class="screen-reader-text" for="pluginzip"><?php _e('Plugin zip file'); ?></label>
  		<input type="file" id="pluginzip" name="pluginzip" />
! 		<input type="submit" class="button" value="<?php esc_attr_e('Install Now') ?>" />
  	</form>
  <?php
  }
  add_action('install_plugins_upload', 'install_plugins_upload', 10, 1);
  
  /**
   * Display plugin content based on plugin list.
   *
   * @since 2.7.0
--- 142,180 ----
   */
  function install_plugins_upload( $page = 1 ) {
  ?>
! 	<h4><?php _e('Install a plugin in .zip format'); ?></h4>
! 	<p class="install-help"><?php _e('If you have a plugin in a .zip format, you may install it by uploading it here.'); ?></p>
! 	<form method="post" enctype="multipart/form-data" class="wp-upload-form" action="<?php echo self_admin_url('update.php?action=upload-plugin'); ?>">
! 		<?php wp_nonce_field( 'plugin-upload'); ?>
  		<label class="screen-reader-text" for="pluginzip"><?php _e('Plugin zip file'); ?></label>
  		<input type="file" id="pluginzip" name="pluginzip" />
! 		<?php submit_button( __( 'Install Now' ), 'button', 'install-plugin-submit', false ); ?>
  	</form>
  <?php
  }
  add_action('install_plugins_upload', 'install_plugins_upload', 10, 1);
  
  /**
+  * Show a username form for the favorites page
+  * @since 3.5.0
+  *
+  */
+ function install_plugins_favorites_form() {
+ 	$user = ! empty( $_GET['user'] ) ? stripslashes( $_GET['user'] ) : get_user_option( 'wporg_favorites' );
+ 	?>
+ 	<p class="install-help"><?php _e( 'If you have marked plugins as favorites on WordPress.org, you can browse them here.' ); ?></p>
+ 	<form method="get" action="">
+ 		<input type="hidden" name="tab" value="favorites" />
+ 		<p>
+ 			<label for="user"><?php _e( 'Your WordPress.org username:' ); ?></label>
+ 			<input type="search" id="user" name="user" value="<?php echo esc_attr( $user ); ?>" />
+ 			<input type="submit" class="button" value="<?php esc_attr_e( 'Get Favorites' ); ?>" />
+ 		</p>
+ 	</form>
+ 	<?php
+ }
+ 
+ /**
   * Display plugin content based on plugin list.
   *
   * @since 2.7.0
***************
*** 162,173 ****
  function display_plugins_table() {
  	global $wp_list_table;
  
  	$wp_list_table->display();
  }
! add_action('install_plugins_search', 'display_plugins_table');
! add_action('install_plugins_featured', 'display_plugins_table');
! add_action('install_plugins_popular', 'display_plugins_table');
! add_action('install_plugins_new', 'display_plugins_table');
  
  /**
   * Determine the status we can perform on a plugin.
--- 182,197 ----
  function display_plugins_table() {
  	global $wp_list_table;
  
+ 	if ( current_filter() == 'install_plugins_favorites' && empty( $_GET['user'] ) && ! get_user_option( 'wporg_favorites' ) )
+ 			return;
+ 
  	$wp_list_table->display();
  }
! add_action( 'install_plugins_search',    'display_plugins_table' );
! add_action( 'install_plugins_featured',  'display_plugins_table' );
! add_action( 'install_plugins_popular',   'display_plugins_table' );
! add_action( 'install_plugins_new',       'display_plugins_table' );
! add_action( 'install_plugins_favorites', 'display_plugins_table' );
  
  /**
   * Determine the status we can perform on a plugin.
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/plugin.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/plugin.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/plugin.php	2012-10-29 12:35:31.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/plugin.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 573,581 ****
   * @since 2.5.0
   *
   * @param string|array $plugins Single plugin or list of plugins to deactivate.
   * @param mixed $network_wide Whether to deactivate the plugin for all sites in the network.
   * 	A value of null (the default) will deactivate plugins for both the site and the network.
-  * @param bool $silent Prevent calling deactivation hooks. Default is false.
   */
  function deactivate_plugins( $plugins, $silent = false, $network_wide = null ) {
  	if ( is_multisite() )
--- 573,581 ----
   * @since 2.5.0
   *
   * @param string|array $plugins Single plugin or list of plugins to deactivate.
+  * @param bool $silent Prevent calling deactivation hooks. Default is false.
   * @param mixed $network_wide Whether to deactivate the plugin for all sites in the network.
   * 	A value of null (the default) will deactivate plugins for both the site and the network.
   */
  function deactivate_plugins( $plugins, $silent = false, $network_wide = null ) {
  	if ( is_multisite() )
***************
*** 606,612 ****
  			$key = array_search( $plugin, $current );
  			if ( false !== $key ) {
  				$do_blog = true;
! 				array_splice( $current, $key, 1 );
  			}
  		}
  
--- 606,612 ----
  			$key = array_search( $plugin, $current );
  			if ( false !== $key ) {
  				$do_blog = true;
! 				unset( $current[ $key ] );
  			}
  		}
  
***************
*** 884,890 ****
   * @param string $capability The capability required for this menu to be displayed to the user.
   * @param string $menu_slug The slug name to refer to this menu by (should be unique for this menu)
   * @param callback $function The function to be called to output the content for this page.
!  * @param string $icon_url The url to the icon to be used for this menu
   * @param int $position The position in the menu order this one should appear
   *
   * @return string The resulting page's hook_suffix
--- 884,891 ----
   * @param string $capability The capability required for this menu to be displayed to the user.
   * @param string $menu_slug The slug name to refer to this menu by (should be unique for this menu)
   * @param callback $function The function to be called to output the content for this page.
!  * @param string $icon_url The url to the icon to be used for this menu. Using 'none' would leave div.wp-menu-image empty
!  *                         so an icon can be added as background with CSS.
   * @param int $position The position in the menu order this one should appear
   *
   * @return string The resulting page's hook_suffix
***************
*** 901,912 ****
  	if ( !empty( $function ) && !empty( $hookname ) && current_user_can( $capability ) )
  		add_action( $hookname, $function );
  
! 	if ( empty($icon_url) )
! 		$icon_url = esc_url( admin_url( 'images/generic.png' ) );
! 	elseif ( is_ssl() && 0 === strpos($icon_url, 'http://') )
! 		$icon_url = 'https://' . substr($icon_url, 7);
  
! 	$new_menu = array( $menu_title, $capability, $menu_slug, $page_title, 'menu-top ' . $hookname, $hookname, $icon_url );
  
  	if ( null === $position )
  		$menu[] = $new_menu;
--- 902,916 ----
  	if ( !empty( $function ) && !empty( $hookname ) && current_user_can( $capability ) )
  		add_action( $hookname, $function );
  
! 	if ( empty($icon_url) ) {
! 		$icon_url = 'none';
! 		$icon_class = 'menu-icon-generic ';
! 	} else {
! 		$icon_url = set_url_scheme( $icon_url );
! 		$icon_class = '';
! 	}
  
! 	$new_menu = array( $menu_title, $capability, $menu_slug, $page_title, 'menu-top ' . $icon_class . $hookname, $hookname, $icon_url );
  
  	if ( null === $position )
  		$menu[] = $new_menu;
***************
*** 1624,1633 ****
  	global $new_whitelist_options;
  
  	if ( 'misc' == $option_group ) {
! 		_deprecated_argument( __FUNCTION__, '3.0', __( 'The miscellaneous options group has been removed. Use another settings group.' ) );
  		$option_group = 'general';
  	}
  
  	$new_whitelist_options[ $option_group ][] = $option_name;
  	if ( $sanitize_callback != '' )
  		add_filter( "sanitize_option_{$option_name}", $sanitize_callback );
--- 1628,1642 ----
  	global $new_whitelist_options;
  
  	if ( 'misc' == $option_group ) {
! 		_deprecated_argument( __FUNCTION__, '3.0', sprintf( __( 'The "%s" options group has been removed. Use another settings group.' ), 'misc' ) );
  		$option_group = 'general';
  	}
  
+ 	if ( 'privacy' == $option_group ) {
+ 		_deprecated_argument( __FUNCTION__, '3.5', sprintf( __( 'The "%s" options group has been removed. Use another settings group.' ), 'privacy' ) );
+ 		$option_group = 'reading';
+ 	}
+ 
  	$new_whitelist_options[ $option_group ][] = $option_name;
  	if ( $sanitize_callback != '' )
  		add_filter( "sanitize_option_{$option_name}", $sanitize_callback );
***************
*** 1647,1656 ****
  	global $new_whitelist_options;
  
  	if ( 'misc' == $option_group ) {
! 		_deprecated_argument( __FUNCTION__, '3.0', __( 'The miscellaneous options group has been removed. Use another settings group.' ) );
  		$option_group = 'general';
  	}
  
  	$pos = array_search( $option_name, (array) $new_whitelist_options );
  	if ( $pos !== false )
  		unset( $new_whitelist_options[ $option_group ][ $pos ] );
--- 1656,1670 ----
  	global $new_whitelist_options;
  
  	if ( 'misc' == $option_group ) {
! 		_deprecated_argument( __FUNCTION__, '3.0', sprintf( __( 'The "%s" options group has been removed. Use another settings group.' ), 'misc' ) );
  		$option_group = 'general';
  	}
  
+ 	if ( 'privacy' == $option_group ) {
+ 		_deprecated_argument( __FUNCTION__, '3.5', sprintf( __( 'The "%s" options group has been removed. Use another settings group.' ), 'privacy' ) );
+ 		$option_group = 'reading';
+ 	}
+ 
  	$pos = array_search( $option_name, (array) $new_whitelist_options );
  	if ( $pos !== false )
  		unset( $new_whitelist_options[ $option_group ][ $pos ] );
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/post.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/post.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/post.php	2012-10-29 12:35:31.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/post.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 26,31 ****
--- 26,45 ----
  	if ( $update )
  		$post_data['ID'] = (int) $post_data['post_ID'];
  
+ 	$ptype = get_post_type_object( $post_data['post_type'] );
+ 
+ 	if ( $update && ! current_user_can( $ptype->cap->edit_post, $post_data['ID'] ) ) {
+ 		if ( 'page' == $post_data['post_type'] )
+ 			return new WP_Error( 'edit_others_pages', __( 'You are not allowed to edit pages as this user.' ) );
+ 		else
+ 			return new WP_Error( 'edit_others_posts', __( 'You are not allowed to edit posts as this user.' ) );
+ 	} elseif ( ! $update && ! current_user_can( $ptype->cap->create_posts ) ) {
+ 		if ( 'page' == $post_data['post_type'] )
+ 			return new WP_Error( 'edit_others_pages', __( 'You are not allowed to create pages as this user.' ) );
+ 		else
+ 			return new WP_Error( 'edit_others_posts', __( 'You are not allowed to create posts as this user.' ) );
+ 	}
+ 
  	if ( isset( $post_data['content'] ) )
  		$post_data['post_content'] = $post_data['content'];
  
***************
*** 51,71 ****
  		}
  	}
  
! 	$ptype = get_post_type_object( $post_data['post_type'] );
! 	if ( isset($post_data['user_ID']) && ($post_data['post_author'] != $post_data['user_ID']) ) {
! 		if ( !current_user_can( $ptype->cap->edit_others_posts ) ) {
! 			if ( 'page' == $post_data['post_type'] ) {
! 				return new WP_Error( 'edit_others_pages', $update ?
! 					__( 'You are not allowed to edit pages as this user.' ) :
! 					__( 'You are not allowed to create pages as this user.' )
! 				);
! 			} else {
! 				return new WP_Error( 'edit_others_posts', $update ?
! 					__( 'You are not allowed to edit posts as this user.' ) :
! 					__( 'You are not allowed to post as this user.' )
! 				);
! 			}
! 		}
  	}
  
  	// What to do based on which button they pressed
--- 65,77 ----
  		}
  	}
  
! 	if ( ! $update && isset( $post_data['user_ID'] ) && ( $post_data['post_author'] != $post_data['user_ID'] )
! 		 && ! current_user_can( $ptype->cap->edit_others_posts ) ) {
! 
! 		if ( 'page' == $post_data['post_type'] )
! 			return new WP_Error( 'edit_others_pages', __( 'You are not allowed to create pages as this user.' ) );
! 		else
! 			return new WP_Error( 'edit_others_posts', __( 'You are not allowed to create posts as this user.' ) );
  	}
  
  	// What to do based on which button they pressed
***************
*** 123,128 ****
--- 129,138 ----
  		$mn = ($mn > 59 ) ? $mn -60 : $mn;
  		$ss = ($ss > 59 ) ? $ss -60 : $ss;
  		$post_data['post_date'] = sprintf( "%04d-%02d-%02d %02d:%02d:%02d", $aa, $mm, $jj, $hh, $mn, $ss );
+ 		$valid_date = wp_checkdate( $mm, $jj, $aa, $post_data['post_date'] );
+ 		if ( !$valid_date ) {
+ 			return new WP_Error( 'invalid_date', __( 'Whoops, the provided date is invalid.' ) );
+ 		}
  		$post_data['post_date_gmt'] = get_gmt_from_date( $post_data['post_date'] );
  	}
  
***************
*** 158,178 ****
  			wp_die( __('You are not allowed to edit this post.' ));
  	}
  
- 	// Autosave shouldn't save too soon after a real save
- 	if ( 'autosave' == $post_data['action'] ) {
- 		$post =& get_post( $post_ID );
- 		$now = time();
- 		$then = strtotime($post->post_date_gmt . ' +0000');
- 		$delta = AUTOSAVE_INTERVAL / 2;
- 		if ( ($now - $then) < $delta )
- 			return $post_ID;
- 	}
- 
  	$post_data = _wp_translate_postdata( true, $post_data );
  	if ( is_wp_error($post_data) )
  		wp_die( $post_data->get_error_message() );
! 	if ( 'autosave' != $post_data['action'] && 'auto-draft' == $post_data['post_status'] )
  		$post_data['post_status'] = 'draft';
  
  	if ( isset($post_data['visibility']) ) {
  		switch ( $post_data['visibility'] ) {
--- 168,179 ----
  			wp_die( __('You are not allowed to edit this post.' ));
  	}
  
  	$post_data = _wp_translate_postdata( true, $post_data );
  	if ( is_wp_error($post_data) )
  		wp_die( $post_data->get_error_message() );
! 	if ( ( empty( $post_data['action'] ) || 'autosave' != $post_data['action'] ) && 'auto-draft' == $post_data['post_status'] ) {
  		$post_data['post_status'] = 'draft';
+ 	}
  
  	if ( isset($post_data['visibility']) ) {
  		switch ( $post_data['visibility'] ) {
***************
*** 223,228 ****
--- 224,244 ----
  		}
  	}
  
+ 	// Attachment stuff
+ 	if ( 'attachment' == $post_data['post_type'] ) {
+ 		if ( isset( $post_data[ '_wp_attachment_image_alt' ] ) ) {
+ 			$image_alt = get_post_meta( $post_ID, '_wp_attachment_image_alt', true );
+ 			if ( $image_alt != stripslashes( $post_data['_wp_attachment_image_alt'] ) ) {
+ 				$image_alt = wp_strip_all_tags( stripslashes( $post_data['_wp_attachment_image_alt'] ), true );
+ 				// update_meta expects slashed
+ 				update_post_meta( $post_ID, '_wp_attachment_image_alt', addslashes( $image_alt ) );
+ 			}
+ 		}
+ 
+ 		$attachment_data = isset( $post_data['attachments'][ $post_ID ] ) ? $post_data['attachments'][ $post_ID ] : array();
+ 		$post_data = apply_filters( 'attachment_fields_to_save', $post_data, $attachment_data );
+ 	}
+ 
  	add_meta( $post_ID );
  
  	update_post_meta( $post_ID, '_edit_last', $GLOBALS['current_user']->ID );
***************
*** 399,405 ****
   * @since 2.0.0
   *
   * @param string $post_type A post type string, defaults to 'post'.
!  * @return object stdClass object containing all the default post data as attributes
   */
  function get_default_post_to_edit( $post_type = 'post', $create_in_db = false ) {
  	global $wpdb;
--- 415,421 ----
   * @since 2.0.0
   *
   * @param string $post_type A post type string, defaults to 'post'.
!  * @return WP_Post Post object containing all the default post data as attributes
   */
  function get_default_post_to_edit( $post_type = 'post', $create_in_db = false ) {
  	global $wpdb;
***************
*** 439,444 ****
--- 455,461 ----
  		$post->page_template = 'default';
  		$post->post_parent = 0;
  		$post->menu_order = 0;
+ 		$post = new WP_Post( $post );
  	}
  
  	$post->post_content = apply_filters( 'default_content', $post_content, $post );
***************
*** 450,486 ****
  }
  
  /**
-  * Get the default page information to use.
-  *
-  * @since 2.5.0
-  *
-  * @return object stdClass object containing all the default post data as attributes
-  */
- function get_default_page_to_edit() {
- 	$page = get_default_post_to_edit();
- 	$page->post_type = 'page';
- 	return $page;
- }
- 
- /**
-  * Get an existing post and format it for editing.
-  *
-  * @since 2.0.0
-  *
-  * @param unknown_type $id
-  * @return unknown
-  */
- function get_post_to_edit( $id ) {
- 
- 	$post = get_post( $id, OBJECT, 'edit' );
- 
- 	if ( $post->post_type == 'page' )
- 		$post->page_template = get_post_meta( $id, '_wp_page_template', true );
- 
- 	return $post;
- }
- 
- /**
   * Determine if a post exists based on title, content, and date
   *
   * @since 2.0.0
--- 467,472 ----
***************
*** 516,522 ****
  	}
  
  	if ( !empty ( $args ) )
! 		return $wpdb->get_var( $wpdb->prepare($query, $args) );
  
  	return 0;
  }
--- 502,508 ----
  	}
  
  	if ( !empty ( $args ) )
! 		return (int) $wpdb->get_var( $wpdb->prepare($query, $args) );
  
  	return 0;
  }
***************
*** 745,751 ****
   * @return unknown
   */
  function _fix_attachment_links( $post_ID ) {
! 	$post = & get_post( $post_ID, ARRAY_A );
  	$content = $post['post_content'];
  
  	// quick sanity check, don't run if no pretty permalinks or post is not published
--- 731,737 ----
   * @return unknown
   */
  function _fix_attachment_links( $post_ID ) {
! 	$post = get_post( $post_ID, ARRAY_A );
  	$content = $post['post_content'];
  
  	// quick sanity check, don't run if no pretty permalinks or post is not published
***************
*** 893,915 ****
  }
  
  /**
-  * Get default post mime types
-  *
-  * @since 2.9.0
-  *
-  * @return array
-  */
- function get_post_mime_types() {
- 	$post_mime_types = array(	//	array( adj, noun )
- 		'image' => array(__('Images'), __('Manage Images'), _n_noop('Image <span class="count">(%s)</span>', 'Images <span class="count">(%s)</span>')),
- 		'audio' => array(__('Audio'), __('Manage Audio'), _n_noop('Audio <span class="count">(%s)</span>', 'Audio <span class="count">(%s)</span>')),
- 		'video' => array(__('Video'), __('Manage Video'), _n_noop('Video <span class="count">(%s)</span>', 'Video <span class="count">(%s)</span>')),
- 	);
- 
- 	return apply_filters('post_mime_types', $post_mime_types);
- }
- 
- /**
   * {@internal Missing Short Description}}
   *
   * @since 2.5.0
--- 879,884 ----
***************
*** 925,936 ****
  }
  
  /**
!  * {@internal Missing Short Description}}
   *
   * @since 2.5.0
   *
!  * @param unknown_type $q
!  * @return unknown
   */
  function wp_edit_attachments_query( $q = false ) {
  	if ( false === $q )
--- 894,907 ----
  }
  
  /**
!  * Executes a query for attachments. An array of WP_Query arguments
!  * can be passed in, which will override the arguments set by this function.
   *
   * @since 2.5.0
+  * @uses apply_filters() Calls 'upload_per_page' on posts_per_page argument
   *
!  * @param array|bool $q Array of query variables to use to build the query or false to use $_GET superglobal.
!  * @return array
   */
  function wp_edit_attachments_query( $q = false ) {
  	if ( false === $q )
***************
*** 1010,1016 ****
   * @return array With two entries of type string
   */
  function get_sample_permalink($id, $title = null, $name = null) {
! 	$post = &get_post($id);
  	if ( !$post->ID )
  		return array('', '');
  
--- 981,987 ----
   * @return array With two entries of type string
   */
  function get_sample_permalink($id, $title = null, $name = null) {
! 	$post = get_post($id);
  	if ( !$post->ID )
  		return array('', '');
  
***************
*** 1063,1086 ****
  }
  
  /**
!  * sample permalink html
!  *
!  * intended to be used for the inplace editor of the permalink post slug on in the post (and page?) editor.
   *
   * @since 2.5.0
   *
   * @param int|object $id Post ID or post object.
!  * @param string $new_title (optional) New title
!  * @param string $new_slug (optional) New slug
!  * @return string intended to be used for the inplace editor of the permalink post slug on in the post (and page?) editor.
   */
  function get_sample_permalink_html( $id, $new_title = null, $new_slug = null ) {
  	global $wpdb;
! 	$post = &get_post($id);
  
  	list($permalink, $post_name) = get_sample_permalink($post->ID, $new_title, $new_slug);
  
! 	if ( 'publish' == $post->post_status ) {
  		$ptype = get_post_type_object($post->post_type);
  		$view_post = $ptype->labels->view_item;
  		$title = __('Click to edit this part of the permalink');
--- 1034,1055 ----
  }
  
  /**
!  * Returns the HTML of the sample permalink slug editor.
   *
   * @since 2.5.0
   *
   * @param int|object $id Post ID or post object.
!  * @param string $new_title Optional. New title.
!  * @param string $new_slug Optional. New slug.
!  * @return string The HTML of the sample permalink slug editor.
   */
  function get_sample_permalink_html( $id, $new_title = null, $new_slug = null ) {
  	global $wpdb;
! 	$post = get_post($id);
  
  	list($permalink, $post_name) = get_sample_permalink($post->ID, $new_title, $new_slug);
  
! 	if ( 'publish' == get_post_status( $post ) ) {
  		$ptype = get_post_type_object($post->post_type);
  		$view_post = $ptype->labels->view_item;
  		$title = __('Click to edit this part of the permalink');
***************
*** 1089,1099 ****
  	}
  
  	if ( false === strpos($permalink, '%postname%') && false === strpos($permalink, '%pagename%') ) {
! 		$return = '<strong>' . __('Permalink:') . "</strong>\n" . '<span id="sample-permalink">' . $permalink . "</span>\n";
  		if ( '' == get_option( 'permalink_structure' ) && current_user_can( 'manage_options' ) && !( 'page' == get_option('show_on_front') && $id == get_option('page_on_front') ) )
! 			$return .= '<span id="change-permalinks"><a href="options-permalink.php" class="button" target="_blank">' . __('Change Permalinks') . "</a></span>\n";
! 		if ( isset($view_post) )
! 			$return .= "<span id='view-post-btn'><a href='$permalink' class='button' target='_blank'>$view_post</a></span>\n";
  
  		$return = apply_filters('get_sample_permalink_html', $return, $id, $new_title, $new_slug);
  
--- 1058,1068 ----
  	}
  
  	if ( false === strpos($permalink, '%postname%') && false === strpos($permalink, '%pagename%') ) {
! 		$return = '<strong>' . __('Permalink:') . "</strong>\n" . '<span id="sample-permalink" tabindex="-1">' . $permalink . "</span>\n";
  		if ( '' == get_option( 'permalink_structure' ) && current_user_can( 'manage_options' ) && !( 'page' == get_option('show_on_front') && $id == get_option('page_on_front') ) )
! 			$return .= '<span id="change-permalinks"><a href="options-permalink.php" class="button button-small" target="_blank">' . __('Change Permalinks') . "</a></span>\n";
! 		if ( isset( $view_post ) )
! 			$return .= "<span id='view-post-btn'><a href='$permalink' class='button button-small'>$view_post</a></span>\n";
  
  		$return = apply_filters('get_sample_permalink_html', $return, $id, $new_title, $new_slug);
  
***************
*** 1118,1129 ****
  	$display_link = str_replace(array('%pagename%','%postname%'), $post_name_html, $permalink);
  	$view_link = str_replace(array('%pagename%','%postname%'), $post_name, $permalink);
  	$return =  '<strong>' . __('Permalink:') . "</strong>\n";
! 	$return .= '<span id="sample-permalink">' . $display_link . "</span>\n";
  	$return .= '&lrm;'; // Fix bi-directional text display defect in RTL languages.
! 	$return .= '<span id="edit-slug-buttons"><a href="#post_name" class="edit-slug button hide-if-no-js" onclick="editPermalink(' . $id . '); return false;">' . __('Edit') . "</a></span>\n";
  	$return .= '<span id="editable-post-name-full">' . $post_name . "</span>\n";
  	if ( isset($view_post) )
! 		$return .= "<span id='view-post-btn'><a href='$view_link' class='button' target='_blank'>$view_post</a></span>\n";
  
  	$return = apply_filters('get_sample_permalink_html', $return, $id, $new_title, $new_slug);
  
--- 1087,1098 ----
  	$display_link = str_replace(array('%pagename%','%postname%'), $post_name_html, $permalink);
  	$view_link = str_replace(array('%pagename%','%postname%'), $post_name, $permalink);
  	$return =  '<strong>' . __('Permalink:') . "</strong>\n";
! 	$return .= '<span id="sample-permalink" tabindex="-1">' . $display_link . "</span>\n";
  	$return .= '&lrm;'; // Fix bi-directional text display defect in RTL languages.
! 	$return .= '<span id="edit-slug-buttons"><a href="#post_name" class="edit-slug button button-small hide-if-no-js" onclick="editPermalink(' . $id . '); return false;">' . __('Edit') . "</a></span>\n";
  	$return .= '<span id="editable-post-name-full">' . $post_name . "</span>\n";
  	if ( isset($view_post) )
! 		$return .= "<span id='view-post-btn'><a href='$view_link' class='button button-small'>$view_post</a></span>\n";
  
  	$return = apply_filters('get_sample_permalink_html', $return, $id, $new_title, $new_slug);
  
***************
*** 1136,1151 ****
   * @since 2.9.0
   *
   * @param int $thumbnail_id ID of the attachment used for thumbnail
!  * @param int $post_id ID of the post associated with the thumbnail, defaults to global $post_ID
   * @return string html
   */
! function _wp_post_thumbnail_html( $thumbnail_id = null, $post_id = null ) {
! 	global $content_width, $_wp_additional_image_sizes, $post_ID;
  
! 	if ( empty( $post_id ) )
! 		$post_id = $post_ID;
  
! 	$upload_iframe_src = esc_url( get_upload_iframe_src('image', $post_id) );
  	$set_thumbnail_link = '<p class="hide-if-no-js"><a title="' . esc_attr__( 'Set featured image' ) . '" href="%s" id="set-post-thumbnail" class="thickbox">%s</a></p>';
  	$content = sprintf( $set_thumbnail_link, $upload_iframe_src, esc_html__( 'Set featured image' ) );
  
--- 1105,1119 ----
   * @since 2.9.0
   *
   * @param int $thumbnail_id ID of the attachment used for thumbnail
!  * @param mixed $post The post ID or object associated with the thumbnail, defaults to global $post.
   * @return string html
   */
! function _wp_post_thumbnail_html( $thumbnail_id = null, $post = null ) {
! 	global $content_width, $_wp_additional_image_sizes;
  
! 	$post = get_post( $post );
  
! 	$upload_iframe_src = esc_url( get_upload_iframe_src('image', $post->ID ) );
  	$set_thumbnail_link = '<p class="hide-if-no-js"><a title="' . esc_attr__( 'Set featured image' ) . '" href="%s" id="set-post-thumbnail" class="thickbox">%s</a></p>';
  	$content = sprintf( $set_thumbnail_link, $upload_iframe_src, esc_html__( 'Set featured image' ) );
  
***************
*** 1157,1170 ****
  		else
  			$thumbnail_html = wp_get_attachment_image( $thumbnail_id, 'post-thumbnail' );
  		if ( !empty( $thumbnail_html ) ) {
! 			$ajax_nonce = wp_create_nonce( "set_post_thumbnail-$post_id" );
  			$content = sprintf( $set_thumbnail_link, $upload_iframe_src, $thumbnail_html );
  			$content .= '<p class="hide-if-no-js"><a href="#" id="remove-post-thumbnail" onclick="WPRemoveThumbnail(\'' . $ajax_nonce . '\');return false;">' . esc_html__( 'Remove featured image' ) . '</a></p>';
  		}
  		$content_width = $old_content_width;
  	}
  
! 	return apply_filters( 'admin_post_thumbnail_html', $content );
  }
  
  /**
--- 1125,1138 ----
  		else
  			$thumbnail_html = wp_get_attachment_image( $thumbnail_id, 'post-thumbnail' );
  		if ( !empty( $thumbnail_html ) ) {
! 			$ajax_nonce = wp_create_nonce( 'set_post_thumbnail-' . $post->ID );
  			$content = sprintf( $set_thumbnail_link, $upload_iframe_src, $thumbnail_html );
  			$content .= '<p class="hide-if-no-js"><a href="#" id="remove-post-thumbnail" onclick="WPRemoveThumbnail(\'' . $ajax_nonce . '\');return false;">' . esc_html__( 'Remove featured image' ) . '</a></p>';
  		}
  		$content_width = $old_content_width;
  	}
  
! 	return apply_filters( 'admin_post_thumbnail_html', $content, $post->ID );
  }
  
  /**
***************
*** 1222,1229 ****
   * @return none
   */
  function _admin_notice_post_locked() {
! 	global $post;
! 
  	$lock = explode( ':', get_post_meta( $post->ID, '_edit_lock', true ) );
  	$user = isset( $lock[1] ) ? $lock[1] : get_post_meta( $post->ID, '_edit_last', true );
  	$last_user = get_userdata( $user );
--- 1190,1196 ----
   * @return none
   */
  function _admin_notice_post_locked() {
! 	$post = get_post();
  	$lock = explode( ':', get_post_meta( $post->ID, '_edit_lock', true ) );
  	$user = isset( $lock[1] ) ? $lock[1] : get_post_meta( $post->ID, '_edit_last', true );
  	$last_user = get_userdata( $user );
